"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.padding = exports.Control = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const icons_js_1 = require("./icons.cjs");
const padding = {
    [icons_js_1.Sizes.SMALL]: 5,
    [icons_js_1.Sizes.MEDIUM]: 5,
    [icons_js_1.Sizes.LARGE]: 5
};
exports.padding = padding;
const button = ({ size, align, type }) => {
    const styles = {
        margin: 0,
        padding: `${padding[size]}px`,
        border: 'none',
        borderRadius: `${icons_js_1.iconSizes[size]}px`,
        color: 'black',
        cursor: 'pointer',
        display: 'flex',
        alignItems: 'center',
        justifyContent: 'center',
        backgroundColor: 'transparent'
    };
    if (type === 'replay') {
        // Include left/right padding + gutter
        const value = `-${icons_js_1.iconSizes[size] + 2 * padding[size] + 5}px`;
        const property = align === 'horizontal' ? 'right' : 'bottom';
        return Object.assign(Object.assign({}, styles), { [property]: value, position: 'absolute', background: '#f2f1f1a6', zIndex: 9999 });
    }
    return styles;
};
const Control = (_a) => {
    var { title, type, onClick, size = icons_js_1.Sizes.MEDIUM, align = 'horizontal' } = _a, rest = __rest(_a, ["title", "type", "onClick", "size", "align"]);
    const styleDataId = 'tts-react-controls';
    const svg = (0, react_1.useMemo)(() => {
        return icons_js_1.icons[type](size);
    }, [type, size]);
    const btnStyle = (0, react_1.useMemo)(() => button({ size, align, type }), [size, align, type]);
    (0, react_1.useEffect)(() => {
        // Keep pseudo styles in stylesheets where they are supported.
        let style = document.querySelector(`style[data-id="${styleDataId}"]`);
        if (!style) {
            style = document.createElement('style');
            style.setAttribute('data-id', styleDataId);
            style.innerHTML = `
        button[data-tts-react-control]:hover {
          background-color: #ebeaeaa6 !important;
        }
        button[data-id="tts-react-replay"]:hover {
          filter: brightness(0.98);
        }
      `;
            document.head.appendChild(style);
        }
        return () => {
            // Cleanup reference to DOM element
            style = null;
        };
    }, [align, size, type]);
    return ((0, jsx_runtime_1.jsx)("button", Object.assign({ title: title, "data-tts-react-control": true, "data-id": `tts-react-${type}`, onClick: onClick, style: btnStyle, dangerouslySetInnerHTML: { __html: svg } }, rest)));
};
exports.Control = Control;
