"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.punctuationRgx = exports.noop = exports.isPunctuation = exports.stripPunctuation = exports.isStringOrNumber = void 0;
const punctuationRgx = /[^\P{P}'/-]+/gu;
exports.punctuationRgx = punctuationRgx;
const isStringOrNumber = (value) => {
    return typeof value === 'string' || typeof value === 'number';
};
exports.isStringOrNumber = isStringOrNumber;
const stripPunctuation = (text) => {
    return text.replace(punctuationRgx, '');
};
exports.stripPunctuation = stripPunctuation;
const isPunctuation = (text) => {
    const trimmed = text.trim();
    return punctuationRgx.test(trimmed) && trimmed.length === 1;
};
exports.isPunctuation = isPunctuation;
const noop = () => { };
exports.noop = noop;
