var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var _Controller_instances, _Controller_target, _Controller_synthesizer, _Controller_dispatchBoundaries, _Controller_fetchAudioData, _Controller_marks, _Controller_text, _Controller_lang, _Controller_aborter, _Controller_initialized, _Controller_initWebSpeechVoice, _Controller_attachAudioSource, _Controller_dispatchEnd, _Controller_dispatchError, _Controller_dispatchReady, _Controller_dispatchPlaying, _Controller_dispatchPaused, _Controller_dispatchBoundary, _Controller_dispatchVolume, _Controller_dispatchRate, _Controller_dispatchPitch, _Controller_playHtmlAudio, _Controller_getPollySpeechMarkForAudioTime, _Controller_getBoundaryWordCharLength, _Controller_clamp, _Controller_recycle, _Controller_utteranceInit, _Controller_htmlAudioInit;
import { isPunctuation } from './utils.js';
var Events;
(function (Events) {
    Events["BOUNDARY"] = "boundary";
    Events["END"] = "end";
    Events["ERROR"] = "error";
    Events["PAUSED"] = "paused";
    Events["PITCH"] = "pitch";
    Events["PLAYING"] = "playing";
    Events["RATE"] = "rate";
    Events["READY"] = "ready";
    Events["VOLUME"] = "volume";
})(Events || (Events = {}));
class Controller extends EventTarget {
    constructor(options) {
        var _a, _b;
        super();
        _Controller_instances.add(this);
        _Controller_target.set(this, void 0);
        _Controller_synthesizer.set(this, void 0);
        _Controller_dispatchBoundaries.set(this, true);
        _Controller_fetchAudioData.set(this, () => Promise.resolve({ audio: '', marks: [] }));
        _Controller_marks.set(this, []);
        _Controller_text.set(this, '');
        _Controller_lang.set(this, '');
        _Controller_aborter.set(this, new AbortController());
        _Controller_initialized.set(this, false);
        __classPrivateFieldSet(this, _Controller_lang, (_a = options === null || options === void 0 ? void 0 : options.lang) !== null && _a !== void 0 ? _a : __classPrivateFieldGet(this, _Controller_lang, "f"), "f");
        __classPrivateFieldSet(this, _Controller_synthesizer, globalThis.speechSynthesis, "f");
        __classPrivateFieldSet(this, _Controller_target, new SpeechSynthesisUtterance(__classPrivateFieldGet(this, _Controller_text, "f")), "f");
        __classPrivateFieldSet(this, _Controller_dispatchBoundaries, (_b = options === null || options === void 0 ? void 0 : options.dispatchBoundaries) !== null && _b !== void 0 ? _b : __classPrivateFieldGet(this, _Controller_dispatchBoundaries, "f"), "f");
        if (options === null || options === void 0 ? void 0 : options.fetchAudioData) {
            __classPrivateFieldSet(this, _Controller_target, __classPrivateFieldSet(this, _Controller_synthesizer, new Audio(), "f"), "f");
            __classPrivateFieldSet(this, _Controller_fetchAudioData, options.fetchAudioData, "f");
        }
        else {
            __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_initWebSpeechVoice).call(this, options === null || options === void 0 ? void 0 : options.voice);
            if (globalThis.speechSynthesis) {
                globalThis.speechSynthesis.onvoiceschanged = () => {
                    __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_initWebSpeechVoice).call(this, options === null || options === void 0 ? void 0 : options.voice);
                };
            }
        }
    }
    get synthesizer() {
        return __classPrivateFieldGet(this, _Controller_synthesizer, "f");
    }
    get target() {
        return __classPrivateFieldGet(this, _Controller_target, "f");
    }
    set text(value) {
        __classPrivateFieldSet(this, _Controller_text, value, "f");
        if (__classPrivateFieldGet(this, _Controller_target, "f") instanceof SpeechSynthesisUtterance) {
            __classPrivateFieldGet(this, _Controller_target, "f").text = value;
        }
    }
    get paused() {
        return __classPrivateFieldGet(this, _Controller_synthesizer, "f").paused;
    }
    get rate() {
        if (__classPrivateFieldGet(this, _Controller_synthesizer, "f") instanceof HTMLAudioElement) {
            return __classPrivateFieldGet(this, _Controller_synthesizer, "f").playbackRate;
        }
        return __classPrivateFieldGet(this, _Controller_target, "f").rate;
    }
    set rate(value) {
        const clamped = __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_clamp).call(this, parseFloat(value.toPrecision(3)), 0.1, 10);
        if (!Number.isNaN(clamped)) {
            __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_dispatchRate).call(this, clamped);
            if (__classPrivateFieldGet(this, _Controller_synthesizer, "f") instanceof HTMLAudioElement) {
                __classPrivateFieldGet(this, _Controller_synthesizer, "f").defaultPlaybackRate = clamped;
                __classPrivateFieldGet(this, _Controller_synthesizer, "f").playbackRate = clamped;
            }
            if (__classPrivateFieldGet(this, _Controller_target, "f") instanceof SpeechSynthesisUtterance) {
                __classPrivateFieldGet(this, _Controller_target, "f").rate = clamped;
            }
        }
    }
    get pitch() {
        if (__classPrivateFieldGet(this, _Controller_target, "f") instanceof SpeechSynthesisUtterance) {
            return __classPrivateFieldGet(this, _Controller_target, "f").pitch;
        }
        // Not supported by HTMLAudioElement
        return -1;
    }
    set pitch(value) {
        if (__classPrivateFieldGet(this, _Controller_target, "f") instanceof SpeechSynthesisUtterance) {
            const clamped = __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_clamp).call(this, parseFloat(value.toPrecision(2)), 0, 2);
            if (!Number.isNaN(clamped)) {
                __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_dispatchPitch).call(this, clamped);
                __classPrivateFieldGet(this, _Controller_target, "f").pitch = clamped;
            }
        }
    }
    get volumeMin() {
        return 0;
    }
    get volumeMax() {
        return 1;
    }
    get volume() {
        return __classPrivateFieldGet(this, _Controller_target, "f").volume;
    }
    set volume(value) {
        const clamped = __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_clamp).call(this, parseFloat(value.toPrecision(2)), this.volumeMin, this.volumeMax);
        if (!Number.isNaN(clamped)) {
            __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_dispatchVolume).call(this, clamped);
            __classPrivateFieldGet(this, _Controller_target, "f").volume = clamped;
        }
    }
    get preservesPitch() {
        if (__classPrivateFieldGet(this, _Controller_synthesizer, "f") instanceof HTMLAudioElement) {
            return __classPrivateFieldGet(this, _Controller_synthesizer, "f").preservesPitch;
        }
        return false;
    }
    set preservesPitch(value) {
        if (__classPrivateFieldGet(this, _Controller_synthesizer, "f") instanceof HTMLAudioElement) {
            __classPrivateFieldGet(this, _Controller_synthesizer, "f").preservesPitch = value;
        }
    }
    get lang() {
        return __classPrivateFieldGet(this, _Controller_lang, "f");
    }
    set lang(value) {
        if (__classPrivateFieldGet(this, _Controller_target, "f") instanceof SpeechSynthesisUtterance) {
            __classPrivateFieldSet(this, _Controller_lang, value, "f");
            __classPrivateFieldGet(this, _Controller_target, "f").lang = value;
            __classPrivateFieldGet(this, _Controller_target, "f").voice = null;
            __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_initWebSpeechVoice).call(this);
        }
    }
    /**
     * Allows listeners for controller events to be registered
     * before instances start firing events related to underlying API's,
     * for instance in a useEffect block.
     *
     * Run it as async to allow for the fetchAudioData call to be awaited.
     */
    init() {
        return __awaiter(this, void 0, void 0, function* () {
            if (!__classPrivateFieldGet(this, _Controller_initialized, "f")) {
                if (__classPrivateFieldGet(this, _Controller_target, "f") instanceof SpeechSynthesisUtterance) {
                    __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_utteranceInit).call(this);
                }
                if (__classPrivateFieldGet(this, _Controller_target, "f") instanceof HTMLAudioElement) {
                    yield __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_htmlAudioInit).call(this);
                }
                __classPrivateFieldSet(this, _Controller_initialized, true, "f");
            }
        });
    }
    play() {
        return __awaiter(this, void 0, void 0, function* () {
            if (__classPrivateFieldGet(this, _Controller_synthesizer, "f") instanceof HTMLAudioElement) {
                yield __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_playHtmlAudio).call(this);
            }
            else {
                __classPrivateFieldGet(this, _Controller_synthesizer, "f").speak(__classPrivateFieldGet(this, _Controller_target, "f"));
            }
        });
    }
    pause() {
        __classPrivateFieldGet(this, _Controller_synthesizer, "f").pause();
    }
    resume() {
        return __awaiter(this, void 0, void 0, function* () {
            if (__classPrivateFieldGet(this, _Controller_synthesizer, "f") instanceof HTMLAudioElement) {
                yield __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_playHtmlAudio).call(this);
            }
            else {
                __classPrivateFieldGet(this, _Controller_synthesizer, "f").resume();
            }
        });
    }
    replay() {
        return __awaiter(this, void 0, void 0, function* () {
            if (__classPrivateFieldGet(this, _Controller_synthesizer, "f") instanceof HTMLAudioElement) {
                __classPrivateFieldGet(this, _Controller_synthesizer, "f").load();
                yield __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_playHtmlAudio).call(this);
            }
            else {
                // Take out of any paused state
                __classPrivateFieldGet(this, _Controller_synthesizer, "f").resume();
                // Drop all utterances in the queue
                __classPrivateFieldGet(this, _Controller_synthesizer, "f").cancel();
                // Start speaking from the beginning
                __classPrivateFieldGet(this, _Controller_synthesizer, "f").speak(__classPrivateFieldGet(this, _Controller_target, "f"));
            }
        });
    }
    cancel() {
        if (__classPrivateFieldGet(this, _Controller_synthesizer, "f") instanceof HTMLAudioElement) {
            __classPrivateFieldGet(this, _Controller_synthesizer, "f").load();
        }
        else {
            __classPrivateFieldGet(this, _Controller_synthesizer, "f").cancel();
        }
    }
    mute() {
        return __awaiter(this, void 0, void 0, function* () {
            this.volume = 0;
            /**
             * There is no way to effectively mute an ongoing utterance for SpeechSynthesis.
             * If there is currently an utterance being spoken, replay to activate the muting instantly.
             */
            if (!(__classPrivateFieldGet(this, _Controller_synthesizer, "f") instanceof HTMLAudioElement) &&
                !this.paused &&
                __classPrivateFieldGet(this, _Controller_synthesizer, "f").speaking) {
                yield this.replay();
            }
        });
    }
    unmute(volume) {
        return __awaiter(this, void 0, void 0, function* () {
            this.volume = volume !== null && volume !== void 0 ? volume : 1;
            /**
             * Same as muting, for SpeechSynthesis have to replay to activate the volume change instantly.
             */
            if (!(__classPrivateFieldGet(this, _Controller_synthesizer, "f") instanceof HTMLAudioElement) &&
                !this.paused &&
                __classPrivateFieldGet(this, _Controller_synthesizer, "f").speaking) {
                yield this.replay();
            }
        });
    }
}
_Controller_target = new WeakMap(), _Controller_synthesizer = new WeakMap(), _Controller_dispatchBoundaries = new WeakMap(), _Controller_fetchAudioData = new WeakMap(), _Controller_marks = new WeakMap(), _Controller_text = new WeakMap(), _Controller_lang = new WeakMap(), _Controller_aborter = new WeakMap(), _Controller_initialized = new WeakMap(), _Controller_instances = new WeakSet(), _Controller_initWebSpeechVoice = function _Controller_initWebSpeechVoice(voice) {
    var _a;
    if (__classPrivateFieldGet(this, _Controller_target, "f") instanceof SpeechSynthesisUtterance) {
        let voices = globalThis.speechSynthesis.getVoices();
        if (voice) {
            __classPrivateFieldGet(this, _Controller_target, "f").voice = voice;
        }
        if (__classPrivateFieldGet(this, _Controller_lang, "f")) {
            voices = voices.filter((voice) => voice.lang === __classPrivateFieldGet(this, _Controller_lang, "f"));
            __classPrivateFieldGet(this, _Controller_target, "f").voice = (_a = voices[0]) !== null && _a !== void 0 ? _a : null;
            if (voice && voice.lang === __classPrivateFieldGet(this, _Controller_lang, "f")) {
                __classPrivateFieldGet(this, _Controller_target, "f").voice = voice;
            }
        }
    }
}, _Controller_attachAudioSource = function _Controller_attachAudioSource() {
    return __awaiter(this, void 0, void 0, function* () {
        var _a;
        if (__classPrivateFieldGet(this, _Controller_synthesizer, "f") instanceof HTMLAudioElement) {
            let data = null;
            try {
                data = yield __classPrivateFieldGet(this, _Controller_fetchAudioData, "f").call(this, __classPrivateFieldGet(this, _Controller_text, "f"));
            }
            catch (err) {
                if (err instanceof Error) {
                    __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_dispatchError).call(this, err.message);
                }
            }
            finally {
                if (data === null || data === void 0 ? void 0 : data.audio) {
                    __classPrivateFieldGet(this, _Controller_synthesizer, "f").src = data.audio;
                    __classPrivateFieldSet(this, _Controller_marks, (_a = data.marks) !== null && _a !== void 0 ? _a : __classPrivateFieldGet(this, _Controller_marks, "f"), "f");
                }
            }
        }
    });
}, _Controller_dispatchEnd = function _Controller_dispatchEnd(evt) {
    this.dispatchEvent(new CustomEvent(Events.END, { detail: evt }));
}, _Controller_dispatchError = function _Controller_dispatchError(msg) {
    this.dispatchEvent(new CustomEvent(Events.ERROR, { detail: msg }));
}, _Controller_dispatchReady = function _Controller_dispatchReady() {
    this.dispatchEvent(new Event(Events.READY));
}, _Controller_dispatchPlaying = function _Controller_dispatchPlaying(evt) {
    this.dispatchEvent(new CustomEvent(Events.PLAYING, { detail: evt }));
}, _Controller_dispatchPaused = function _Controller_dispatchPaused(evt) {
    this.dispatchEvent(new CustomEvent(Events.PAUSED, { detail: evt }));
}, _Controller_dispatchBoundary = function _Controller_dispatchBoundary(evt, boundary) {
    this.dispatchEvent(new CustomEvent(Events.BOUNDARY, { detail: { evt, boundary } }));
}, _Controller_dispatchVolume = function _Controller_dispatchVolume(volume) {
    this.dispatchEvent(new CustomEvent(Events.VOLUME, { detail: volume }));
}, _Controller_dispatchRate = function _Controller_dispatchRate(rate) {
    this.dispatchEvent(new CustomEvent(Events.RATE, { detail: rate }));
}, _Controller_dispatchPitch = function _Controller_dispatchPitch(pitch) {
    this.dispatchEvent(new CustomEvent(Events.PITCH, { detail: pitch }));
}, _Controller_playHtmlAudio = function _Controller_playHtmlAudio() {
    return __awaiter(this, void 0, void 0, function* () {
        const audio = __classPrivateFieldGet(this, _Controller_synthesizer, "f");
        try {
            yield audio.play();
        }
        catch (err) {
            if (err instanceof Error) {
                __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_dispatchError).call(this, err.message);
            }
        }
    });
}, _Controller_getPollySpeechMarkForAudioTime = function _Controller_getPollySpeechMarkForAudioTime(time) {
    const length = __classPrivateFieldGet(this, _Controller_marks, "f").length;
    let bestMatch = __classPrivateFieldGet(this, _Controller_marks, "f")[0];
    let found = false;
    let i = 1;
    while (i < length && !found) {
        if (__classPrivateFieldGet(this, _Controller_marks, "f")[i].time <= time) {
            bestMatch = __classPrivateFieldGet(this, _Controller_marks, "f")[i];
        }
        else {
            found = true;
        }
        i++;
    }
    return bestMatch;
}, _Controller_getBoundaryWordCharLength = function _Controller_getBoundaryWordCharLength(startIndex) {
    const match = __classPrivateFieldGet(this, _Controller_text, "f").substring(startIndex).match(/.+?\b/);
    return match ? match[0].length : 0;
}, _Controller_clamp = function _Controller_clamp(value, min = 0, max = 1) {
    return Math.max(min, Math.min(value, max));
}, _Controller_recycle = function _Controller_recycle() {
    __classPrivateFieldGet(this, _Controller_aborter, "f").abort();
    __classPrivateFieldSet(this, _Controller_aborter, new AbortController(), "f");
    return __classPrivateFieldGet(this, _Controller_aborter, "f").signal;
}, _Controller_utteranceInit = function _Controller_utteranceInit() {
    if (__classPrivateFieldGet(this, _Controller_target, "f") instanceof SpeechSynthesisUtterance) {
        const signal = __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_recycle).call(this);
        __classPrivateFieldGet(this, _Controller_target, "f").addEventListener('end', __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_dispatchEnd).bind(this), { signal });
        __classPrivateFieldGet(this, _Controller_target, "f").addEventListener('start', __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_dispatchPlaying).bind(this), { signal });
        __classPrivateFieldGet(this, _Controller_target, "f").addEventListener('resume', __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_dispatchPlaying).bind(this), {
            signal
        });
        __classPrivateFieldGet(this, _Controller_target, "f").addEventListener('pause', __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_dispatchPaused).bind(this), { signal });
        __classPrivateFieldGet(this, _Controller_target, "f").addEventListener('error', (evt) => {
            __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_dispatchError).call(this, evt.error);
        }, { signal });
        if (__classPrivateFieldGet(this, _Controller_lang, "f")) {
            __classPrivateFieldGet(this, _Controller_target, "f").lang = __classPrivateFieldGet(this, _Controller_lang, "f");
        }
        if (__classPrivateFieldGet(this, _Controller_dispatchBoundaries, "f")) {
            __classPrivateFieldGet(this, _Controller_target, "f").addEventListener('boundary', (evt) => {
                var _a;
                const { charIndex: startChar } = evt;
                const charLength = (_a = evt.charLength) !== null && _a !== void 0 ? _a : __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_getBoundaryWordCharLength).call(this, startChar);
                const endChar = startChar + charLength;
                const word = __classPrivateFieldGet(this, _Controller_text, "f").substring(startChar, endChar);
                if (word && !isPunctuation(word)) {
                    __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_dispatchBoundary).call(this, evt, { word, startChar, endChar });
                }
            }, { signal });
        }
        __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_dispatchReady).call(this);
    }
}, _Controller_htmlAudioInit = function _Controller_htmlAudioInit() {
    return __awaiter(this, void 0, void 0, function* () {
        if (__classPrivateFieldGet(this, _Controller_target, "f") instanceof HTMLAudioElement) {
            const target = __classPrivateFieldGet(this, _Controller_target, "f");
            __classPrivateFieldGet(this, _Controller_target, "f").addEventListener('canplay', __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_dispatchReady).bind(this), {
                once: true
            });
            __classPrivateFieldGet(this, _Controller_target, "f").addEventListener('playing', __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_dispatchPlaying).bind(this));
            __classPrivateFieldGet(this, _Controller_target, "f").addEventListener('pause', __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_dispatchPaused).bind(this));
            __classPrivateFieldGet(this, _Controller_target, "f").addEventListener('ended', __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_dispatchEnd).bind(this));
            __classPrivateFieldGet(this, _Controller_target, "f").addEventListener('error', () => {
                const error = target.error;
                __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_dispatchError).call(this, error === null || error === void 0 ? void 0 : error.message);
            });
            if (__classPrivateFieldGet(this, _Controller_dispatchBoundaries, "f")) {
                __classPrivateFieldGet(this, _Controller_target, "f").addEventListener('timeupdate', (evt) => {
                    // Polly Speech Marks use milliseconds
                    const currentTime = target.currentTime * 1000;
                    const mark = __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_getPollySpeechMarkForAudioTime).call(this, currentTime);
                    if (mark && !this.paused) {
                        __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_dispatchBoundary).call(this, evt, {
                            word: mark.value,
                            startChar: mark.start,
                            endChar: mark.end
                        });
                    }
                });
            }
            yield __classPrivateFieldGet(this, _Controller_instances, "m", _Controller_attachAudioSource).call(this);
        }
    });
};
/**
 * Stub for when speech synthesis is not supported.
 */
class ControllerStub {
    constructor() {
        this.lang = '';
        this.rate = 1;
        this.pitch = 1;
        this.volume = 1;
        this.volumeMin = 0;
        this.preservesPitch = false;
        this.text = '';
    }
    cancel() { }
    init() {
        return Promise.resolve();
    }
    mute() {
        return Promise.resolve();
    }
    unmute() {
        return Promise.resolve();
    }
    play() {
        return Promise.resolve();
    }
    pause() { }
    resume() {
        return Promise.resolve();
    }
    replay() {
        return Promise.resolve();
    }
    addEventListener() { }
    removeEventListener() { }
}
export { Controller, ControllerStub, Events };
